"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

module.exports =
/*#__PURE__*/
function () {
  function ReduxAdapter(store) {
    (0, _classCallCheck2["default"])(this, ReduxAdapter);
    this.stateWaitMap = {};
    this.store = store;
  } //Search the state for the values we are waiting on
  //State is considered ready when the waiting value is neither
  //undefined or null


  (0, _createClass2["default"])(ReduxAdapter, [{
    key: "checkStateStatus",
    value: function checkStateStatus() {
      var _this = this;

      var state = this.store.getState();
      Object.keys(this.stateWaitMap).forEach(function (stateKey) {
        if (!_this.stateWaitMap[stateKey].resolved) {
          var keys = stateKey.split('.');
          var searchState = state;
          var isSatisfied = true;

          for (var y = 0; y < keys.length; y++) {
            var key = keys[y];

            if (!searchState.hasOwnProperty(key) || searchState[key] == null) {
              //exit we arent ready yet :(
              isSatisfied = false;
              break;
            }

            searchState = searchState[key];
          }

          if (isSatisfied) {
            _this.stateWaitMap[stateKey].resolved = true;

            _this.stateWaitMap[stateKey].resolver(searchState);
          }
        }
      });
    } //This implementation will watch for state changes and resolve once the state values
    //are available

  }, {
    key: "when",
    value: function when(stateProps) {
      var _this2 = this;

      var promises = stateProps.map(function (stateProp) {
        var promise = _this2.stateWaitMap[stateProp];

        if (!promise) {
          promise = new Promise(function (resolve) {
            _this2.stateWaitMap[stateProp] = {
              resolver: resolve,
              resolved: false
            };
          });
        }

        return promise;
      }); //Check for state immediately once

      this.checkStateStatus();
      var unsub = this.store.subscribe(this.checkStateStatus.bind(this));
      return Promise.all(promises).then(function () {
        unsub();
        return _this2.store.getState();
      });
    }
  }]);
  return ReduxAdapter;
}();