"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var PropTypes = require('prop-types');

var React = require('react');

var _require = require('react-redux'),
    Provider = _require.Provider;

var rootProviderSymbol = Symbol();

var RootProvider =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(RootProvider, _React$Component);

  function RootProvider() {
    var _this;

    (0, _classCallCheck2["default"])(this, RootProvider);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(RootProvider).call(this));
    _this[rootProviderSymbol] = true;
    return _this;
  }

  (0, _createClass2["default"])(RootProvider, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      if (!this.props.store) {
        throw new Error("Error Root Provider expects a store passed in as a prop");
      }

      var wrappedElements = [];

      if (Array.isArray(this.props.children)) {
        this.props.children.forEach(function (element, index) {
          if (!RootProvider.isRootProvider(element)) {
            wrappedElements.push(React.createElement(Provider, {
              key: index,
              store: _this2.props.store
            }, element));
          }
        });
      } else {
        wrappedElements.push(React.createElement(Provider, {
          key: 0,
          store: this.props.store
        }, this.props.children));
      }

      return React.createElement('div', null, wrappedElements);
    }
  }], [{
    key: "isRootProvider",
    value: function isRootProvider(elem) {
      return elem[rootProviderSymbol];
    }
  }]);
  return RootProvider;
}(React.Component);

module.exports = RootProvider;
RootProvider.propTypes = {
  store: PropTypes.object.isRequired,
  children: PropTypes.node.isRequired
};